# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Memcache.V1.Model.WeeklyMaintenanceWindow do
  @moduledoc """
  Time window specified for weekly operations.

  ## Attributes

  *   `day` (*type:* `String.t`, *default:* `nil`) - Required. Allows to define schedule that runs specified day of the week.
  *   `duration` (*type:* `String.t`, *default:* `nil`) - Required. Duration of the time window.
  *   `startTime` (*type:* `GoogleApi.Memcache.V1.Model.TimeOfDay.t`, *default:* `nil`) - Required. Start time of the window in UTC.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :day => String.t() | nil,
          :duration => String.t() | nil,
          :startTime => GoogleApi.Memcache.V1.Model.TimeOfDay.t() | nil
        }

  field(:day)
  field(:duration)
  field(:startTime, as: GoogleApi.Memcache.V1.Model.TimeOfDay)
end

defimpl Poison.Decoder, for: GoogleApi.Memcache.V1.Model.WeeklyMaintenanceWindow do
  def decode(value, options) do
    GoogleApi.Memcache.V1.Model.WeeklyMaintenanceWindow.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Memcache.V1.Model.WeeklyMaintenanceWindow do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
