# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Memcache.V1beta2.Model.NodeConfig do
  @moduledoc """
  Configuration for a Memcached Node.

  ## Attributes

  *   `cpuCount` (*type:* `integer()`, *default:* `nil`) - Required. Number of cpus per Memcached node.
  *   `memorySizeMb` (*type:* `integer()`, *default:* `nil`) - Required. Memory size in MiB for each Memcached node.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :cpuCount => integer() | nil,
          :memorySizeMb => integer() | nil
        }

  field(:cpuCount)
  field(:memorySizeMb)
end

defimpl Poison.Decoder, for: GoogleApi.Memcache.V1beta2.Model.NodeConfig do
  def decode(value, options) do
    GoogleApi.Memcache.V1beta2.Model.NodeConfig.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Memcache.V1beta2.Model.NodeConfig do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
