# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Memcache.V1beta2.Model.RescheduleMaintenanceRequest do
  @moduledoc """
  Request for RescheduleMaintenance.

  ## Attributes

  *   `rescheduleType` (*type:* `String.t`, *default:* `nil`) - Required. If reschedule type is SPECIFIC_TIME, must set up schedule_time as well.
  *   `scheduleTime` (*type:* `DateTime.t`, *default:* `nil`) - Timestamp when the maintenance shall be rescheduled to if reschedule_type=SPECIFIC_TIME, in RFC 3339 format, for example `2012-11-15T16:19:00.094Z`.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :rescheduleType => String.t() | nil,
          :scheduleTime => DateTime.t() | nil
        }

  field(:rescheduleType)
  field(:scheduleTime, as: DateTime)
end

defimpl Poison.Decoder, for: GoogleApi.Memcache.V1beta2.Model.RescheduleMaintenanceRequest do
  def decode(value, options) do
    GoogleApi.Memcache.V1beta2.Model.RescheduleMaintenanceRequest.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Memcache.V1beta2.Model.RescheduleMaintenanceRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
